    IMPORT com
    IMPORT xml
     
    MAIN
     DEFINE req        com.HTTPServiceRequest
     DEFINE url        STRING
     DEFINE method     STRING
     DEFINE doc        xml.DomDocument
     DEFINE type       STRING
     DEFINE ind        INTEGER
     DEFINE p          com.HTTPPart
     DEFINE resp       STRING
     DEFINE i          INTEGER
     DEFINE b           BYTE
     DEFINE txt         STRING
     
     DISPLAY "START"
     CALL com.WebServiceEngine.Start()
     
     LET req = com.WebServiceEngine.getHTTPServiceRequest(-1)
     LET url = req.getURL()
     DISPLAY url
     IF url IS NULL  THEN
       DISPLAY "Failed: url should not be null"
       EXIT PROGRAM (-1)    
     END IF
     
     LET method = req.getMethod()
     DISPLAY "method: ", method
     IF method IS NULL OR method != "POST" THEN
       DISPLAY "Failed: method should be POST"
     END IF
     
     # Check multipart type
     LET type = req.getRequestMultipartType()
     DISPLAY "type: ", type
     IF type IS NULL THEN
       DISPLAY "Failed: expected multipart in request"
     END IF
     {
     LOCATE b IN MEMORY
     CALL req.readDataRequest(b)
     CALL b.writeFile("myfile.jpg")
     }
     LET txt = req.readTextRequest()
     DISPLAY "Response is :",txt
     # Process additional parts
     LET resp = "count: ", req.getRequestPartCount()
     DISPLAY resp
     
     FOR ind = 1 TO req.getRequestPartCount()
       LET p = req.getRequestPart(ind)
       IF p.getAttachment() IS NOT NULL THEN
         LET resp = resp, " att: ", p.getAttachment()
         DISPLAY "Attached file at :",p.getAttachment()
       ELSE
         LET resp = resp, " content: ", p.getContentAsString()
         DISPLAY "Attached part is :",p.getContentAsString()
       END IF
     END FOR
     
     CALL req.sendTextResponse(200, "", resp)
     
    END MAIN